package cn.rankin.userservice.controller;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.EventTypeEnum;
import cn.rankin.data.api.user.dto.DownloadInfoDTO;
import cn.rankin.data.api.user.entity.DownloadInfo;
import cn.rankin.data.api.user.entity.UserDevice;
import cn.rankin.userservice.helper.RaStringHelper;
import cn.rankin.userservice.service.DownloadInfoService;
import cn.rankin.userservice.service.UserDeviceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/userDevice")
public class UserDeviceController
{

    @Autowired
    private UserDeviceService userDeviceService;


    @RequestMapping(value = "/bindingDevice/{uid}", method = RequestMethod.GET)
    public UserDevice bindingDevice(@PathVariable("uid") String uid,
                                         @RequestParam("deviceCode") String deviceCode,
                                         @RequestParam("deviceType") String deviceType){

        if(RaStringHelper.isNull(uid))
        {
            return null;
        }
        if(RaStringHelper.isNull(deviceCode))
        {
            return null;
        }
        if(RaStringHelper.isNull(deviceType))
        {
            return null;
        }

        UserDevice userDevice = userDeviceService.findDevice(uid,deviceCode,deviceType);
        if(userDevice!=null)
        {
            int bindingNum = userDevice.getBindingNum()+1;
            userDeviceService.updateDevice(uid,deviceCode,deviceType,bindingNum);
        }

        return userDevice;
    }

}
