package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.EventTypeEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.DownloadInfo;
import cn.rankin.data.api.user.entity.UserDevice;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface UserDeviceRepository extends BasicJpaRepository<UserDevice, String> {

    @Query(value = "select device from UserDevice device where device.userId = ?1 AND device.deviceCode= ?2 AND device.deviceType = ?3")
    UserDevice findUserDevice(String uid, String deviceCode,String deviceType);

    @Transactional
    @Modifying
    @Query(value = "update UserDevice device set device.bindingNum = ?4 where device.userId = ?1 AND device.deviceCode= ?2 AND device.deviceType = ?3")
    int updateDevice(String uid, String deviceCode,String deviceType,int bindingNum);
}
